{$pbe ignore}
unit DefScript;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TPSForm = class(TForm)
    pScriptGUI: TPanel;
    FCmdLineParams: TEdit;
    FStartFolder: TEdit;
    FHideWindow: TCheckBox;
    FWaitFor: TCheckBox;
    FFileList: TMemo;
    FExcludeMasks: TMemo;
    FDontExpandMasks: TCheckBox;
    FOutputVar: TComboBox;    
    lbFCmdLineParams: TLabel;
    lbFStartFolder: TLabel;
    lbFFileList: TLabel;
    lbFExcludeMasks: TLabel;
    lbFOutputVar: TLabel;
    sbFStartFolder: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PSForm: TPSForm;

implementation

{$R *.dfm}

{$end pbe ignore}


procedure sbFFileListClick(Sender:TObject);
var
  s:string;
begin
  case FFileList.Lines.Count of
    0:s:='';
    1:s:=trim(FFileList.Lines.Text);  
  else  
    s:=FFileList.Lines[FFileList.Lines.Count-1]
  end;      

  // mFileMask.Hint contains the defined file extension filters
  if SelectFile(s,mFileMask.Hint) then    
  begin  
    if pos(' ',s)>0 then s:='"'+s+'"';
    if FFileList.SelText<>'' then
      FFileList.SelText:=s    
    else
      FFileList.Lines.Add(s);  
  end;
end;

procedure sbFDestinationClick(Sender:TObject);
var
  s:string;  
  p:TPoint;
begin
  s:=FDestination.Text;    
  p.x:=0; p.y:=sbFDestination.Height;
  p:=sbFDestination.ClientToScreen(p);
  if BrowseForFolder(sbFDestination.Hint,s,s,p) then
    FDestination.Text:=s;    
end;

procedure sbAdvOptionsClick(Sender:TObject);
begin
  pAdvOptions.Visible:=not pAdvOptions.Visible;
  if pAdvOptions.Visible then  
    sbAdvOptions.Caption:='< '+sbAdvOptions.Hint    
  else 
    sbAdvOptions.Caption:=sbAdvOptions.Hint+' >';        
end;

procedure sbFStartFolderClick(Sender:TObject);
var
  s:string;  
  p:TPoint;
begin
  s:=FStartFolder.text;    
  p.x:=0; p.y:=sbFStartFolder.Height;
  p:=sbFStartFolder.ClientToScreen(p);
  if BrowseForFolder(sbFStartFolder.Hint,s,s,p) then  
    FStartFolder.Text:=s;
end;

procedure ParseCmdLineParams;
var
  i:integer;  
  tmp,cl:string;
begin  
  cl:='dummy.exe '+ReplaceText(FCmdLineParams.Text,'/c copy ','');
  cbFSwitchV.Checked:=FindMyCmdLineSwitch(cl,'V',True);  
  cbFSwitchY.Checked:=FindMyCmdLineSwitch(cl,'Y',True);
  for i:=MyCmdLineParamCount(cl) downto 1 do
  begin    
    tmp:=MyCmdLineParamStr(cl,i);        
    if Length(tmp)>0 then
    begin    
      if (tmp[1]<>'-') and (tmp[1]<>'/') and (UpperCase(tmp)<>'%FILE%') then      
      begin      
        FDestination.Text:=tmp;        
        break;
      end;
    end;     
  end;
end;

procedure UpdateCmdLineParams(Sender:TObject);
var
  tmp,d:string;
begin
  tmp:='/C copy'; // calling the "copy" system command  
  if cbFSwitchV.checked then tmp:=tmp+' /V';  
  if cbFSwitchY.checked then tmp:=tmp+' /Y';  
  tmp:=tmp+' %FILE%';
  if FDestination.Text<>'' then  
  begin  
    d:=FDestination.Text;    
    if d[1]='"' then    
      tmp:=tmp+' '+FDestination.Text
    else 
      tmp:=tmp+' "'+FDestination.Text+'"';    
  end;
  FCmdLineParams.Text:=tmp;
end;  

{---------- SaveSettings: Required method! -------------------------------------
  Here you can transform values from your GUI into the required fields
  of default Precision Builder Express command-line interface.   

  Fields description:  

  edParams.Text [required] 
    - command line parameters for the executed application (defined in action type "Advanced tab")

  mFileMask.Lines.Text [optional] 
    - the list of processed files (or any other parameters), that will be used 
      if edParams.Text contains the %FILE% macro
          
  mExcludeMask.Lines.Text [optional] 
    - the list of excluded masks, that is applied on files list (only if cbDontExpandMask.Checked is False),    
      or copied to the edParams.Text replacing the %EXCLUDE% macro
     
  edStartFolder.Text [optional] 
    - working folder for the executed application

  cbHideWindow.Checked [optional]
    - show or hide the application window 

  cbWaitFor.Checked [optional] 
    - wait for the application completion   

  cbDontExpandMask.Checked [optional] 
    - indicates if PBE should expand the list of processed files by the defined masks 
      (replace masks by real file names)
     
  cbVar.Text [optional]               
    - identifier of the project variable, where the output of application
      will be saved (only applicable when action type "Use output file" is checked)
-------------------------------------------------------------------------------}
procedure SaveSettings;
begin
  UpdateCmdLineParams(nil);  

  mFileMask.Lines.Text:=FFileList.Lines.Text;
  //mExcludeMask.Lines.Text:=FExcludeMasks.Lines.Text;
  edParams.Text:=FCmdLineParams.Text;
  edStartFolder.Text:=FStartFolder.Text;
  cbHideWindow.Checked:=FHideWindow.Checked;
  cbWaitFor.Checked:=FWaitFor.Checked;
  cbDontExpandMask.Checked:=FDontExpandMasks.Checked;
  cbVar.Text:=FOutputVar.Text;
end;

{---------- LoadSettings: Required method! ------------------------------------- 
  Here you can transform the Precision Builder Express command-line interface  
  fields into the values of your GUI. See the description of fields above.     
-------------------------------------------------------------------------------}
procedure LoadSettings;
begin
  FCmdLineParams.Text:=edParams.Text;
  FStartFolder.Text:=edStartFolder.Text;
  FHideWindow.Checked:=cbHideWindow.Checked;
  FWaitFor.Checked:=cbWaitFor.Checked;
  FFileList.Lines.Text:=mFileMask.Lines.Text;  
  FFileList.Hint:=FFileList.Hint+'|'+mFileMask.Hint;
  //FExcludeMasks.Lines.Text:=mExcludeMask.Lines.Text;  
  //FExcludeMasks.Hint:=FExcludeMasks.Hint+'|'+mExcludeMask.Hint;
  FDontExpandMasks.Checked:=cbDontExpandMask.Checked;
  if cbVar.Parent=tsCommandLine then
  begin
    FOutputVar.Items.Text:=cbVar.Items.Text;
    FOutputVar.Text:=cbVar.Text;
  end
  else  
  begin
    FOutputVar.Visible:=False;
    lbFOutputVar.Visible:=False;    
  end;  

  sbFStartFolder.OnClick:=@sbFStartFolderClick;  
end;

{---------- Main script body ---------------------------------------------------
  Calling the LoadSettings method is required!      
-------------------------------------------------------------------------------}
begin
  LoadSettings;
  ParseCmdLineParams;   
  sbFFileList.OnClick:=@sbFFileListClick;    
  sbFDestination.OnClick:=@sbFDestinationClick;    
  sbAdvOptions.OnClick:=@sbAdvOptionsClick;  
  cbFSwitchV.OnClick:=@UpdateCmdLineParams;  
  cbFSwitchY.OnClick:=@UpdateCmdLineParams;  
  FDestination.OnChange:=@UpdateCmdLineParams;
end.